#include "r4300.h"
#include "memhand.h"
#include "main.h"
#include "debug.h"
#include "video.h"
#include "vesa.h"

extern VesaModeData vesa_mode;
char *video;

void vesa_set_page(signed long vpage)
{
  static page;
  union   REGS    regs;
#ifdef DEBUG_EXEC
  lastexec;
#endif
  regs.x.ax = 0x4f05;
  regs.x.bx = 0;
  regs.x.cx = 0;
  regs.x.dx = (unsigned short int)(vpage == 0 ? 0 : (unsigned short int)((vpage * 64) / 64));
  int86(0x10,&regs,&regs);
  regs.x.ax = 0x4f05;
  regs.x.bx = 1;
  regs.x.cx = 0;
  regs.x.dx = (unsigned short int)(vpage == 0 ? 0 : (unsigned short int)((vpage * 64) / 64));
  int86(0x10,&regs,&regs);
}

void vesa_swap (signed long int swidth, signed long int sheight, signed long int bpp)
{
  void    *dest;
  signed long  page            = 0;
  signed long  scr_size        = (swidth * sheight * bpp);     //width * height * bytes per pixel.
  unsigned char locolor;
  unsigned char hicolor;
  int i, x = 0;
  int r;
  int g;
  int b;
  WORD *color;
  int r_x = 0, r_y = 0;
  video = (char *)0xa0000+__djgpp_conventional_base;

#ifdef DEBUG_EXEC
  lastexec;
#endif
  while(scr_size > 0)
  {
    vesa_set_page(page);

    for (i = 0; i < (scr_size > 65536 ? 65536 : scr_size);)
    {
      if (r_x <= 640)
      {
        *color = getword(getdword(0x04400004) + x); // BGRA
        b=(*color>>11)&0x1f;
        g=(*color>>6)&0x1f;
        r=(*color>>1)&0x1f;

        locolor=((r)+(g<<5))&0xff;
        hicolor=((g>>3)+(b<<2))&0xff;

        video[i] = locolor;
        video[i+1] = hicolor;

        x += 2;
      }
      i += 2;
      r_x += 2;
      if (r_x > 640*2)
      {
        r_x = 0;
        r_y ++;
        if (r_y > 240)
          break;
      }
    }
    scr_size -= 65536;
    page++;
  }
}

void Do_Video_Banked ( void  )
{
  int i, x = 0;
#ifdef DEBUG_EXEC
  lastexec;
#endif
  __djgpp_nearptr_enable();
  vesa_swap(640,480,2);
  __djgpp_nearptr_disable();
}

void Do_Video_LFB ( void )
{
  int i = 0;
  unsigned int Video_DRAM = getdword(0x04400004);
  short int b;
  short int g;
  short int r;
  WORD *color;
  unsigned char locolor;
  unsigned char hicolor;
  int x, y;

#ifdef DEBUG_EXEC
  lastexec;
#endif
  __djgpp_nearptr_enable();
  for (y = 0; y < 480; y++)
  {
    if (y > 240)
      break;
    for (x = 0; x < 640*2; x+=2)
    {
      if (x < 640)
      {
#ifdef DEBUG_EXEC
  lastexec;
#endif
        *color = getword((unsigned int)Video_DRAM + i); // BGRA
        b=(*color>>11)&0x1f;
        g=(*color>>6)&0x1f;
        r=(*color>>1)&0x1f;

        locolor=((r)+(g<<5))&0xff;
        hicolor=((g>>3)+(b<<2))&0xff;
        video[(y*(640*2))+ x] = locolor;
        video[(y*(640*2))+ x + 1] = hicolor;
        i+=2;
      }
      else
        break;
    }
  }
  __djgpp_nearptr_disable();
}

void SetVideoMode ( unsigned short int mode )
{
  // Sets video mode //
  union REGS inregs, outregs;
  inregs.h.al= 0x02;
  inregs.h.ah= 0x4f;
  inregs.x.bx=(unsigned short int)mode;

  int86(0x10, &inregs, &outregs);
}

void (*Do_Video)();

void Set_Video_Type ( void (*video_handler)())
{
  Do_Video = video_handler;
}

void Init_Video ( void )
{
  vesa_get_mode_info(0x110);
  if (!LFB)
  {
    SetVideoMode(0x110);
    Set_Video_Type(Do_Video_Banked);
  }
  else
  {
    Set_Video_Type(Do_Video_LFB);
  }
}

void Reset_Video ( void )
{
  __dpmi_regs regs;
  regs.x.ax=0x03;
  __dpmi_int(0x10, &regs);
}

